//
//  LottozahlenAppDelegate.m
//  Lottozahlen
//
//  Created by Holger Hinzberg
//  http://www.cocoa-coding.de/kids 

#import "LottoController.h"

@implementation LottoController

@synthesize window;
@synthesize zufallszahl1;
@synthesize zufallszahl2;
@synthesize zufallszahl3;
@synthesize zufallszahl4;
@synthesize zufallszahl5;
@synthesize zufallszahl6;
@synthesize superzahl;

- (void)awakeFromNib
{ 
    srandom((uint)time(NULL));
}


- (IBAction)lottoSpielen:(id)sender
{
    // Array erzeugen und initialisieren
    NSMutableArray *zufallsArray;
    zufallsArray = [[NSMutableArray alloc] init];
    
    NSNumber *zufallszahl;
    bool istEinmalig = true;
    
    // for-Schleife für sechs Lottozahlen 
    for  (int a = 0; a < 6; a++)
    { 
        istEinmalig = false;
        
        while(istEinmalig == false)
        {
            // Zufallszahl erzeugen
            zufallszahl = [[NSNumber alloc]
                           initWithInt:(int)(random() % 49) + 1]; 
            
            // Bis zur Prüfung ist diese Zahl
            // einmalig.
            istEinmalig = true;
            
            // Jedes Objekt im Array muss 
            // mit den neu ausgelosten Zahl 
            // verglichen werden
            for (int x = 0; x < [zufallsArray count]; x++)
            {
                
                // Vergleichen
                if ([zufallszahl intValue] == 
                    [[zufallsArray objectAtIndex:x] intValue])
                {
                    // Übereinstimmung gefunden!
                    // Diese Zahl gibt es schon!
                    istEinmalig = false;
                    break;
                }
                
            } // Ende der inneren for-Schleife
        } // Ende der while-Schleife
        
        // Zahl ist einmalig. Dem Array hinzufügen
        [zufallsArray addObject: zufallszahl]; 
    } // Ende der äußeren for-Schleife
  
    
    // Diese Anweisung sortiert die Zahlen im Array 
    [zufallsArray sortUsingSelector:
     @selector(compare:)];
    
    // Ausgabe : Die Zahlen aus dem Array
    // an die Textfelder senden. 
    int zahl = [[zufallsArray objectAtIndex:0] intValue];
    [zufallszahl1 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:1] intValue];
    [zufallszahl2 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:2] intValue];
    [zufallszahl3 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:3] intValue];
    [zufallszahl4 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:4] intValue];
    [zufallszahl5 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:5] intValue];
    [zufallszahl6 setIntValue:zahl];
    
    // Und jetzt noch die Superzahl
    int sZahl = (int)(random() % 9) + 1; 
    [superzahl setIntValue:sZahl];
}




@end
