//
//  LottozahlenAppDelegate.m
//  Lottozahlen

//  Created by Holger Hinzberg
//  http://www.cocoa-coding.de/kids 

// Diese Lösung des Lottozahlengenerators 
// geht einen etwas änderen Weg und erzeugt zunächst 
// ein Array mit den den Zahlen 1 bis 49 aus dem dann an an einer zufälligen 
// Position ein Wert ermittelt wird.
// Das das Objekt anschließend aus dem Array entfernt wird kann es nicht 
// erneut ausgelost werden und das Array der Zahlen wird kürzer während
// das Array der zufallszahlen länder wird.
//
// Mein Dank geht an Paul Gölz für die Idee und den ursprünglichen Programmcode. 


#import "LottoController.h"
@implementation LottoController

@synthesize window;
@synthesize zufallszahl1;
@synthesize zufallszahl2;
@synthesize zufallszahl3;
@synthesize zufallszahl4;
@synthesize zufallszahl5;
@synthesize zufallszahl6;

- (void)awakeFromNib
{ 
    srandom((uint)time(NULL));
}


- (IBAction)lottoSpielen:(id)sender
{
    // In dem Array "zahlenArray" werden alle möglichen Ergebnisse
    // gespeichert denn zahlenArray wird mit den 
    // Werten von 1 bis 49 aufgefüllt
    NSMutableArray *zahlenArray;
	zahlenArray = [[NSMutableArray alloc] init];
  
	for (int a = 1; a < 50; a++)
	{
		NSNumber *zahl;
		zahl = [[NSNumber alloc] initWithInt:a];
		[zahlenArray addObject:zahl];
		[zahl release];
	}
	
	//zufallArray beinhaltet die Ergebnisse und 
    // ist zunächst leer. 
    NSMutableArray *zufallsArray;
	zufallsArray = [[NSMutableArray alloc] init];
	
	//Die Schleife für sechs Zahlen.	
    for (int b = 0; b < 6; b++)
	{
		// zufallsPosition ist eine zufällige Position
        // im zahlenArray.        
        // Dabei ist die Länge (count) des zahlenArray wichtig da mit jedem
        // Schleifendurchlauf ein Objekt entfernt wird.
	    
        NSUInteger zufallsPosition = (uint)(random() % [zahlenArray count]);
        
        // Objekt in das zufallArray übernehmen.
		[zufallsArray addObject:[zahlenArray objectAtIndex:zufallsPosition]];
		        
        // Objekt aus dem Array entfernen.
        [zahlenArray removeObjectAtIndex:zufallsPosition];
	}
    
    // Diese Anweisung sortiert die Zahlen im Array 
    [zufallsArray sortUsingSelector:
     @selector(compare:)];
    
    // Ausgabe : Die Zahlen aus dem Array
    // an die Textfelder senden. 
    int zahl = [[zufallsArray objectAtIndex:0] intValue];
    [zufallszahl1 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:1] intValue];
    [zufallszahl2 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:2] intValue];
    [zufallszahl3 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:3] intValue];
    [zufallszahl4 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:4] intValue];
    [zufallszahl5 setIntValue:zahl];
    
    zahl = [[zufallsArray objectAtIndex:5] intValue];
    [zufallszahl6 setIntValue:zahl];
}

@end
